<com.ergotech.transsecs.secs.EquipmentData>
  <HostName Class="java.lang.String">localhost</HostName>
  <DeviceId Class="java.lang.Integer">1</DeviceId>
  <Port Class="java.lang.Integer">5010</Port>
  <VidsDataRoot Class="com.ergotech.transsecs.secs.VIDsData">
    <Name Class="java.lang.String">VIDs</Name>
    <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../.."/>
    <Children Class="java.util.Vector">
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">SetPoint</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">2000</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>2000</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">50</InitialValue>
        <LimitMax Class="java.lang.Double">400.0</LimitMax>
        <LimitMin Class="java.lang.Double">50.0</LimitMin>
        <ModificationDate Class="java.util.Date">2018-08-19 11:47:26.894 MDT</ModificationDate>
        <Script Class="java.lang.String">//script will be executed if there is a change in the device register value for this ECID.&#xd;
print(&quot;ECID SetPoint (2000) value changed&quot;);&#xd;
//for our simulator we can change the random walk server upper limit with the script&#xd;
//in the demo servers SetPointServer&#xd;
//send value to SetPointServer&#xd;
/Devices/DemoServers_Servers/SetPointServer-&gt;setIntValue(incomingValue.getIntValue());</Script>
        <Description Class="java.lang.String">An example ECID. Can be changed by the host with an S2F15 message.</Description>
        <DeviceName Class="java.lang.String">DemoServers</DeviceName>
        <TagName Class="java.lang.String">SetPointServer</TagName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">GasFlow</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">1511</VID>
        <DataType Class="java.lang.Integer">44</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>1511</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <ModificationDate Class="java.util.Date">2018-08-19 11:52:08.459 MDT</ModificationDate>
        <Description Class="java.lang.String">The simulated gas flow value from the DemoServer SimGasFlow</Description>
        <DeviceName Class="java.lang.String">DemoServers</DeviceName>
        <TagName Class="java.lang.String">SimGasFlow</TagName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">ProcessTemperature</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">1512</VID>
        <DataType Class="java.lang.Integer">44</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>1512</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <ModificationDate Class="java.util.Date">2018-08-19 11:53:50.491 MDT</ModificationDate>
        <Description Class="java.lang.String">An example SVID with its value set by the simulated temperature value from the  DemoServer SimTemperature
</Description>
        <DeviceName Class="java.lang.String">DemoServers</DeviceName>
        <TagName Class="java.lang.String">SimTemperature</TagName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">WaferCount</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">1510</VID>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>6004</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <ModificationDate Class="java.util.Date">2018-08-19 11:54:27.822 MDT</ModificationDate>
        <Description Class="java.lang.String">An SVID with a simulated value from the Demo Server WaferIncrementer</Description>
        <DeviceName Class="java.lang.String">DemoServers</DeviceName>
        <TagName Class="java.lang.String">WaferIncrementer</TagName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">MDLN</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33000</VID>
        <DataType Class="java.lang.Integer">20</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33000</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">PLC 01</InitialValue>
        <ModificationDate Class="java.util.Date">2018-08-18 22:11:03.870 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">SOFTREV</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33001</VID>
        <DataType Class="java.lang.Integer">20</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33001</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">Rev1.0</InitialValue>
        <ModificationDate Class="java.util.Date">2018-08-01 17:15:30.473 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">CommunicationsState</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33002</VID>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33002</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">1</InitialValue>
        <ModificationDate Class="java.util.Date">2018-08-19 11:15:50.447 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">ControlState</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33003</VID>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33003</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">1</InitialValue>
        <ModificationDate Class="java.util.Date">2018-08-19 11:15:47.540 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">LastControlState</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33004</VID>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33004</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2018-07-05 13:38:38.814 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">LocalRemoteState</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33005</VID>
        <DataType Class="java.lang.Integer">11</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33005</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2018-08-19 12:31:01.91 MDT</ModificationDate>
        <Description Class="java.lang.String">This is set to 1 (true, REMOTE) to enable the host to connect to the PLCTool. Normally this needs to be connected to a physcial or software (HMI) switch or button in the tool to allow setting LOCAL or REMOTE on the tool.</Description>
        <DeviceName Class="java.lang.String">DemoServers</DeviceName>
        <TagName Class="java.lang.String">LocalRemoteSwitch</TagName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">OnlineOfflineState</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33006</VID>
        <DataType Class="java.lang.Integer">11</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33006</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2018-08-19 12:31:22.911 MDT</ModificationDate>
        <Description Class="java.lang.String">This is set to 1 (true, ONLINE) to enable the host to connect to the PLCTool. Normally this needs to be connected to a physcial or software (HMI) switch or button in the tool to allow setting ONLINE or OFFLINE on the tool.</Description>
        <DeviceName Class="java.lang.String">DemoServers</DeviceName>
        <TagName Class="java.lang.String">OnlineOfflineSwitch</TagName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">TimeFormat</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33007</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33007</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">16</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.482 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">CLOCK</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33008</VID>
        <DataType Class="java.lang.Integer">20</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33008</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.482 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">EstablishCommunicationsTimeout</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33009</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33009</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.482 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">SpoolCountActual</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33010</VID>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33010</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.482 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">SpoolCountTotal</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33011</VID>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33011</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.466 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">EnableSpooling</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33012</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33012</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.466 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">MaxSpoolTransmit</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33013</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33013</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">5</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.466 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">MaxSpoolSize</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33014</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33014</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">100</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.466 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">OverWriteSpool</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33015</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33015</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.466 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">SpoolStartTime</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33016</VID>
        <DataType Class="java.lang.Integer">20</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33016</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.450 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">SpoolFullTime</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33017</VID>
        <DataType Class="java.lang.Integer">20</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33017</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">0</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.450 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">S5F1ReplyBit</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33018</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33018</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">1</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.419 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">EventReportsReplyBit</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33019</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33019</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">1</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.419 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">EventReportFunction</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33020</VID>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33020</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <InitialValue Class="java.lang.String">11</InitialValue>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.404 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">AlarmsEnabled</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33021</VID>
        <DataType Class="java.lang.Integer">0</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33021</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.404 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">AlarmsSet</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33022</VID>
        <DataType Class="java.lang.Integer">0</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33022</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <ModificationDate Class="java.util.Date">2018-07-27 10:03:04.984 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      </com.ergotech.transsecs.secs.VIDData>
      <com.ergotech.transsecs.secs.VIDData>
        <Name Class="java.lang.String">EventsEnabled</Name>
        <Parent Class="com.ergotech.transsecs.secs.VIDsData" reference="../../.."/>
        <VID Class="java.lang.Integer">33023</VID>
        <DataType Class="java.lang.Integer">0</DataType>
        <VIDType Class="java.lang.Integer">2</VIDType>
        <VIDSecsFormat Class="com.ergotech.secs.SecsFormat50">
          <theData>33023</theData>
          <length>8</length>
          <numberOfLengthBytes>-1</numberOfLengthBytes>
        </VIDSecsFormat>
        <ModificationDate Class="java.util.Date">2015-12-10 19:03:32.404 MST</ModificationDate>
      </com.ergotech.transsecs.secs.VIDData>
    </Children>
  </VidsDataRoot>
  <AlidsDataRoot Class="com.ergotech.transsecs.secs.ALIDsData">
    <Name Class="java.lang.String">ALIDs</Name>
    <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../.."/>
    <Children Class="java.util.Vector">
      <com.ergotech.transsecs.secs.ALIDData>
        <Name Class="java.lang.String">GasFlowProblem</Name>
        <ALID Class="java.lang.Integer">5504</ALID>
        <Altx Class="java.lang.String">Problem with Gas Flow</Altx>
        <Alcd Class="java.lang.Byte">10</Alcd>
        <ModificationDate Class="java.util.Date">2015-12-11 22:45:38.402 MST</ModificationDate>
        <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
        <Description Class="java.lang.String">An example alarm.</Description>
        <Parent Class="com.ergotech.transsecs.secs.ALIDsData" reference="../../.."/>
      </com.ergotech.transsecs.secs.ALIDData>
      <com.ergotech.transsecs.secs.ALIDData>
        <Name Class="java.lang.String">TemperatureProblem</Name>
        <ALID Class="java.lang.Integer">5502</ALID>
        <Altx Class="java.lang.String">Temperature Problem</Altx>
        <Alcd Class="java.lang.Byte">10</Alcd>
        <ModificationDate Class="java.util.Date">2013-09-03 15:23:08.887 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">DemoServers</DeviceName>
        <TagName Class="java.lang.String">RandomAlarmTrigger</TagName>
        <Description Class="java.lang.String">An example alarm which is triggered by  a simulated boolean value in the Demo Servers
</Description>
        <Parent Class="com.ergotech.transsecs.secs.ALIDsData" reference="../../.."/>
      </com.ergotech.transsecs.secs.ALIDData>
    </Children>
  </AlidsDataRoot>
  <CeidsDataRoot Class="com.ergotech.transsecs.secs.CEIDsData">
    <Name Class="java.lang.String">CEIDs</Name>
    <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../.."/>
    <Children Class="java.util.Vector">
      <com.ergotech.transsecs.secs.CEIDData>
        <Name Class="java.lang.String">STARTED</Name>
        <Ceid Class="java.lang.Integer">7501</Ceid>
        <DVIDs Class="java.util.ArrayList"/>
        <ModificationDate Class="java.util.Date">2013-09-03 14:14:41.183 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">DemoServers</DeviceName>
        <TagName Class="java.lang.String">RandomEventTrigger</TagName>
        <Description Class="java.lang.String">Event signaling the START of a process.
In this simulation it is triggered by a boolean in the Demo Servers</Description>
        <Parent Class="com.ergotech.transsecs.secs.CEIDsData" reference="../../.."/>
      </com.ergotech.transsecs.secs.CEIDData>
      <com.ergotech.transsecs.secs.CEIDData>
        <Name Class="java.lang.String">COMPLETED</Name>
        <Ceid Class="java.lang.Integer">7502</Ceid>
        <DVIDs Class="java.util.ArrayList"/>
        <ModificationDate Class="java.util.Date">2013-09-03 14:15:11.463 MDT</ModificationDate>
        <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
        <Description Class="java.lang.String">Event signaling the COMPLETION  of a process.</Description>
        <Parent Class="com.ergotech.transsecs.secs.CEIDsData" reference="../../.."/>
      </com.ergotech.transsecs.secs.CEIDData>
    </Children>
  </CeidsDataRoot>
  <DevicesRoot Class="com.ergotech.transsecs.secs.DevicesData">
    <Name Class="java.lang.String">Devices</Name>
    <Description Class="java.lang.String">Devices are data sources for VIDs, ALIDs, and CEIDs. </Description>
    <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../.."/>
    <Children Class="java.util.ArrayList">
      <com.ergotech.transsecs.secs.DeviceManager>
        <Name Class="java.lang.String">_0</Name>
        <Description Class="java.lang.String">Used for testing recipe messages. This is completely static. Add a real PLC Driver for your PLC for development and testing.</Description>
        <Parent Class="com.ergotech.transsecs.secs.DevicesData" reference="../../.."/>
        <Children Class="java.util.ArrayList">
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">S7F5DataReady</Name>
            <Description Class="java.lang.String">When this is non-zero the PPBody is ready to be read from the PLC</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">S7F5DataReady</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">S7F5PPBody</Name>
            <Description Class="java.lang.String">This will be the PPBody for the S7F6 message. If blank (empty) then the request failed.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">S7F5PPBody</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">S7F5RequestPPBodyFlag</Name>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">S7F5RequestPPBodyFlag</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">S7F5PPID</Name>
            <Description Class="java.lang.String">The PPID sent in the S7F5 message</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">S7F5PPID</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">S7F3RecipeProcessComplete</Name>
            <Description Class="java.lang.String">If this is set to &quot;99&quot;, the PLC reports that the S7F3  PPID and PPBody have been stored correctly, ready to send S7F4 reply. If value is other than &quot;99&quot;, but not &quot;0&quot;, this is the error code to be sent in the S7F4.

This is reset to &quot;0&quot; after the S7F4 has been sent.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">S7F3RecipeProcessComplete</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">S7F3RecievedNotification</Name>
            <Description Class="java.lang.String">S7F3 handler writes a &quot;1&quot; to this register to notify the PLC that there is a new PPID and PPBody to process. After the S7F4 reply is sent, this is reset to &quot;0&quot;.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">S7F3RecievedNotification</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">S7F3PPBody</Name>
            <Description Class="java.lang.String">This PLC address contains the PPBody of the received S7F3 message</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">S7F3PPBody</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">S7F3PPID</Name>
            <Description Class="java.lang.String">This PLC address contains the PPID from the S7F3 message</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">S7F3PPID</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
        </Children>
        <Device Class="com.ergotech.vib.servers.ServersDeviceManager">
          <Name Class="java.lang.String">PLCSimulator</Name>
          <Servers Class="[Lcom.ergotech.vib.servers.SimpleDataSource;">
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[8]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[4]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[7]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[6]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[5]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[3]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[2]/Server"/>
          </Servers>
        </Device>
      </com.ergotech.transsecs.secs.DeviceManager>
      <com.ergotech.transsecs.secs.DeviceManager>
        <Description Class="java.lang.String">Demo Servers are simple simulated data sources which substitute for real PLC registers in this exmple</Description>
        <Parent Class="com.ergotech.transsecs.secs.DevicesData" reference="../../.."/>
        <Children Class="java.util.ArrayList">
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">LocalRemoteSwitch</Name>
            <Description Class="java.lang.String">The local/remote switch should be a physcial or softare (HMI) switch or button on the tool to allow the operator to switch between LOCAL and REMOTE states. This value is used by the GEM SVID LocalRemoteState. This simulator sets the value to a 1 (true/REMOTE) for testing purposes.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">LocalRemoteSwitch</Name>
              <Script Class="java.lang.String">1;</Script>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">OnlineOfflineSwitch</Name>
            <Description Class="java.lang.String">The online/offline switch should be a physcial or softare (HMI) switch or button on the tool to allow the operator to switch between ONLINE and OFFLINE states. This value is used by the GEM SVID OnlineOfflineState. This simulator sets the value to a 1 (true/REMOTE) for testing purposes.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">OnlineOfflineSwitch</Name>
              <Script Class="java.lang.String">1;</Script>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">HCACK</Name>
            <Description Class="java.lang.String">The value of this server is used to set the hcack value in the Host Command Reply. It is set to 99 when any HostCommand is recieved. &#xd;
The device will calculate a new hcack value when STOPFlag or STARTFlag is triggered from the HostCommandSTOP or HostCommandSTART.&#xd;
For this simulation, the new hcack value is calculated in the STARTFlag or STOPFlagscripts when they are triggered from their repsective Host Command.&#xd;
&#xd;
</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">HCACK</Name>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">SetPointServer</Name>
            <Description Class="java.lang.String">This is used as a &quot;set point&quot; for the temperature simulator.  Updated by a script in the SetPoint ECID.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">SetPointServer</Name>
              <Script Class="java.lang.String">//this script is called when the host changes ECID 2000 (SetPoint)&#xd;
//SetPoint is a variable for our Demo Servers but is simulating a device (PLC) register.&#xd;
//When the ECID is changed by the host, this register will be updated&#xd;
newValue = incomingValue.getIntValue();&#xd;
//print(&quot;SetPoint changing to &quot; + newValue + &quot; (SetPoint BCS script)&quot;);&#xd;
//now this value is stored in the PLC register, but as a demonstration we well change the&#xd;
//level of the SimTemperature simulator as if the PLC was executing code based on this change&#xd;
try {&#xd;
/Devices/DemoServers_Servers/SimTemperature-&gt;setLevel(newValue);&#xd;
//print(&quot;Temperature simulator level changed to &quot;+ newValue);&#xd;
} catch (e) {&#xd;
    print(&quot;Error in SetPointServer script&quot;);&#xd;
    print(e);    &#xd;
}</Script>
              <AutoSuspend Class="java.lang.Integer">2</AutoSuspend>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">STARTFlag</Name>
            <Description Class="java.lang.String">This simulates a boolean register in the Device  (e.g. PLC) to signal the receipt of a START host command. The RecipeName register will contain the new PPID value from the&#xd;
Host Command message. The device will check the parameter(s) and the tool status to calculate a new HCACK value for the host command reply message.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">STARTFlag</Name>
              <Script Class="java.lang.String">//STARTFlag is a simulated register in the PLC. PLC watches for a change form any number to 99 to start processing the START command.&#xd;
print(&quot;STARTFlag value changed to &quot;+incomingValue.getIntValue()+ &quot; from HostCommandSTART&quot;);&#xd;
//PLC does some work here to determine if the START host command is OK or not&#xd;
java.lang.Thread.sleep(450); //simulate some time the PLC is working on the problem&#xd;
//PLC sets the HCACK flag value (0 or 4 = OK, 2 = cannot perform now, 5 = already started)&#xd;
calculatedHCACK=0;&#xd;
/Devices/DemoServers_Servers/HCACK-&gt;setIntValue(calculatedHCACK);</Script>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">STOPFlag</Name>
            <Description Class="java.lang.String">This simulates a boolean register in the Device  (e.g. PLC)  to signal the receipt of a STOP host command.. The device will check the parameter(s) and the tool status to calculate a new HCACK value for the host command reply message.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">STOPFlag</Name>
              <Script Class="java.lang.String">//STOPFlag is a simulated register in the PLC. PLC watches for a change form any number to 99 to start processing the STOP command.&#xd;
print(&quot;STOPFlag value changed to &quot;+incomingValue.getIntValue()+ &quot; from HostCommandSTOP&quot;);&#xd;
//PLC does some work here to determine if the STOP host command is OK&#xd;
java.lang.Thread.sleep(450); //simulate some time the PLC is working on the problem&#xd;
//PLC sets the HCACK flag value (0 or 4 = OK, 2 = cannot perform now, 5 = already started)&#xd;
calculatedHCACK=0;&#xd;
/Devices/DemoServers_Servers/HCACK-&gt;setIntValue(calculatedHCACK);</Script>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">RecipeName</Name>
            <Description Class="java.lang.String">This is the Device  (e.g. PLC)  register which contains the last PPID sent in the HostCommandSTART</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.manipulators.BroadcastServer">
              <Name Class="java.lang.String">RecipeName</Name>
              <Script Class="java.lang.String"></Script>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">RandomEventTrigger</Name>
            <Description Class="java.lang.String">For this simulation, randomly generates a boolean true which triggers the STARTED event</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.servers.RandomBoolean">
              <Name Class="java.lang.String">RandomEventTrigger</Name>
              <Script Class="java.lang.String"></Script>
              <Timebase Class="java.lang.Double">17.0</Timebase>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">RandomAlarmTrigger</Name>
            <Description Class="java.lang.String">simulate an alarm when transitions 0-&gt;1, clear alarm for 1-&gt;0. Randomly generates a true or false every timebase tick.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.servers.RandomBoolean">
              <Name Class="java.lang.String">RandomAlarmTrigger</Name>
              <Script Class="java.lang.String"></Script>
              <Timebase Class="java.lang.Double">12.0</Timebase>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">WaferIncrementer</Name>
            <Description Class="java.lang.String">Continuously increments the wafer count for this simulation</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.servers.IncrementServer">
              <Name Class="java.lang.String">WaferIncrementer</Name>
              <Script Class="java.lang.String">//print(&quot;Wafer count incremented&quot;);</Script>
              <MaxValue Class="java.lang.Integer">1000000</MaxValue>
              <MinValue Class="java.lang.Integer">1</MinValue>
              <Timebase Class="java.lang.Double">5.0</Timebase>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">SimGasFlow</Name>
            <Description Class="java.lang.String">Simulates the GasFlow VID value. The script is an example of  scaling  the device data.</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.servers.FloatFluxServer">
              <Name Class="java.lang.String">SimGasFlow</Name>
              <Script Class="java.lang.String">//example of scaling the PLC data for the VID&#xd;
output=incomingValue.getFloatValue()*2.0-5;</Script>
              <MaxFluctuation Class="java.lang.Float">0.25</MaxFluctuation>
              <Level Class="java.lang.Float">12.0</Level>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
          <com.ergotech.transsecs.secs.DeviceServer>
            <Name Class="java.lang.String">SimTemperature</Name>
            <Description Class="java.lang.String">Simulates the temperaturefor the ProcessTemperature SVID value</Description>
            <Parent Class="com.ergotech.transsecs.secs.DeviceManager" reference="../../.."/>
            <Server Class="com.ergotech.vib.servers.FloatFluxServer">
              <Name Class="java.lang.String">SimTemperature</Name>
              <Rate Class="java.lang.Float">20.0</Rate>
              <Script Class="java.lang.String"></Script>
              <StartLevel Class="java.lang.Float">120.0</StartLevel>
              <MaxFluctuation Class="java.lang.Float">5.0</MaxFluctuation>
              <Level Class="java.lang.Float">0.0</Level>
              <Timebase Class="java.lang.Double">2.0</Timebase>
            </Server>
          </com.ergotech.transsecs.secs.DeviceServer>
        </Children>
        <Device Class="com.ergotech.vib.servers.ServersDeviceManager">
          <Name Class="java.lang.String">DemoServers</Name>
          <Servers Class="[Lcom.ergotech.vib.servers.SimpleDataSource;">
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[7]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[3]/Server"/>
            <com.ergotech.vib.servers.RandomBoolean reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[8]/Server"/>
            <com.ergotech.vib.servers.FloatFluxServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[11]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[2]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[6]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[4]/Server"/>
            <com.ergotech.vib.servers.FloatFluxServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[12]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[5]/Server"/>
            <com.ergotech.vib.manipulators.BroadcastServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer/Server"/>
            <com.ergotech.vib.servers.RandomBoolean reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[9]/Server"/>
            <com.ergotech.vib.servers.IncrementServer reference="../../../Children/com.ergotech.transsecs.secs.DeviceServer[10]/Server"/>
          </Servers>
        </Device>
      </com.ergotech.transsecs.secs.DeviceManager>
    </Children>
  </DevicesRoot>
  <Description Class="java.lang.String">A SECS/GEM tool example demonstrating GEM IDs and Remote Commands. Use the GEMHost project as a test host or use the SECS Tester. 
</Description>
  <Children Class="java.util.Vector">
    <com.ergotech.transsecs.secs.CEIDsData reference="../../CeidsDataRoot"/>
    <com.ergotech.transsecs.secs.ALIDsData reference="../../AlidsDataRoot"/>
    <com.ergotech.transsecs.secs.VIDsData reference="../../VidsDataRoot"/>
    <com.ergotech.transsecs.secs.DevicesData reference="../../DevicesRoot"/>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">HostCommandSTART</Name>
      <Stream Class="java.lang.Integer">2</Stream>
      <Function Class="java.lang.Integer">41</Function>
      <ExpectsReply Class="java.lang.Boolean">true</ExpectsReply>
      <HandleHostMessageErrors Class="java.lang.Boolean">true</HandleHostMessageErrors>
      <ModificationDate Class="java.util.Date">2007-09-09 07:20:43.820 MDT</ModificationDate>
      <MessageDirection Class="java.lang.Integer">1</MessageDirection>
      <Script Class="java.lang.String">//in this simple example we put the PPID into the &quot;RecipeName&quot; register then set the 
//STARTFlag so the device (PLC) can decide if the command is OK to perform

print(&quot;Host Command START&quot;);
//1. START has been requested. Parse parameter(s) in the message to get the PPID.
//2. Store PPID in RecipeName device regiter
//3.Set STARTFlag in PLC to 99
//4. Wait up to 2000 ms for PLC to signal OK or error in register STARTFlag
//   0 or 4(OK), 2 (cannot perform now), 5 (already in that state)
//5. Send reply to host


var TransSecsController = Java.type(&quot;com.ergotech.transsecs.secs.TransSecsController&quot;);
try {
 
secsInterface=TransSecsController.findController(&quot;PLCTool&quot;);
hostcommand=secsInterface.getMessageBean(&quot;HostCommandSTART&quot;);

//recipe name is the second element of the first parameter array
//Note:if CPName Validation is not used, you need to manually check that there is a
//single CPName which is &quot;PPID&quot;. This example assumes this host message matched HostCommandSTART
recipeName = hostcommand.getCommandParams().elementAt(0).elementAt(1);

/Devices/DemoServers_Servers/RecipeName-&gt;setStringValue(recipeName);

 //initialize HCACK value in device. Device should overwrite this with correct HCACK.
/Devices/DemoServers_Servers/HCACK-&gt;setIntValue(99);

/Devices/DemoServers_Servers/STARTFlag-&gt;setIntValue(99); //doing this triggers the STARTFlag script

//wait up to 2000 ms for STARTFlag to change from 99 to some other number which is the HCACK for the reply message

count=0;
hcack=99;
while ((hcack==99) &amp;&amp; (count&lt;10)) {
    java.lang.Thread.sleep(200);
    count++;
    hcack=/Devices/DemoServers_Servers/HCACK-&gt;getIntValue();
   // print(count+&quot; &quot;+hcack);//debugging
}

//if hcack is still 99 there is a problem with the PLC program, so send error code 99 for PLC timeout

//send reply with the HCACK from the Device

reply = secsInterface.getMessageBean(&quot;HostCommandReply&quot;);
reply.setHCACK(Java.to([hcack],&quot;byte[]&quot;));
//alternatively, the HCACK value can be set this way:
//var SecsFormat10 =  Java.type(&quot;com.ergotech.secs.SecsFormat10&quot;);
//reply.setHCACKFormat ( new SecsFormat10(hack));
reply.sendMessage(); 

//trigger the STARTED Event (as an example of triggering an event). The event will only 
//be triggered if the STARTED CEID has been enabled by the host and if the hcack is 0 or 4 (OK to execute command)

if (hcack==0 || hcack==4) {
startedEvent = secsInterface.getGemHandler().getServerForName(&quot;ceid.STARTED&quot;);
startedEvent.setIntValue(1); //triggers the event
}
//Note: alternatively we can attach a device server tag to the CEID and trigger it with a boolean true


} catch (e) {
    print(&quot;Error in HostCommandSTART script &quot;);
    print(e);    
}
</Script>
      <Description Class="java.lang.String">START Host Command for testing with a parameter (PPID). The script  will send the reply message to the host.</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">AllParams</Name>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Children Class="java.util.Vector">
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">Command</Name>
              <ItemType Class="java.lang.Integer">20</ItemType>
              <DefaultValue Class="java.lang.String">START</DefaultValue>
              <IsKey Class="java.lang.Boolean">true</IsKey>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">CommandParams</Name>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Children Class="java.util.ArrayList">
                <com.ergotech.transsecs.secs.ItemData>
                  <Name Class="java.lang.String">Parm1List</Name>
                  <Publish Class="java.lang.Boolean">true</Publish>
                  <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
                  <Children Class="java.util.ArrayList">
                    <com.ergotech.transsecs.secs.ItemData>
                      <Name Class="java.lang.String">CPName</Name>
                      <ItemType Class="java.lang.Integer">20</ItemType>
                      <DefaultValue Class="java.lang.String">PPID</DefaultValue>
                      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
                      <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
                      <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
                    </com.ergotech.transsecs.secs.ItemData>
                    <com.ergotech.transsecs.secs.ItemData>
                      <Name Class="java.lang.String">CPValue</Name>
                      <ItemType Class="java.lang.Integer">20</ItemType>
                      <Publish Class="java.lang.Boolean">true</Publish>
                      <TagName Class="java.lang.String">RecipeName</TagName>
                      <DeviceName Class="java.lang.String">DemoServers</DeviceName>
                      <Description Class="java.lang.String">//we could use this script to set the RecipeName value in the Device instead of doing it in the HostCommandSTART main script
//for example,
//ppid=incomingValue-&gt;getStringValue();
// /Devices/DemoServers/RecipeName-&gt;setStringValue(ppid);</Description>
                      <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
                      <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
                    </com.ergotech.transsecs.secs.ItemData>
                  </Children>
                  <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
                </com.ergotech.transsecs.secs.ItemData>
              </Children>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
            </com.ergotech.transsecs.secs.ItemData>
          </Children>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">HostCommandSTOP</Name>
      <Stream Class="java.lang.Integer">2</Stream>
      <Function Class="java.lang.Integer">41</Function>
      <ExpectsReply Class="java.lang.Boolean">true</ExpectsReply>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2007-09-09 07:20:43.820 MDT</ModificationDate>
      <MessageDirection Class="java.lang.Integer">1</MessageDirection>
      <Script Class="java.lang.String">var TransSecsController = Java.type(&quot;com.ergotech.transsecs.secs.TransSecsController&quot;);
print(&quot;Host Command STOP&quot;); //for debugging
//1. STOP has been requested. Set flag in PLC to 99
//2. Wait up to 2000 ms for PLC to signal OK or error in register STOPFlag
//3. Send reply to host

try {
 
secsInterface=TransSecsController.findController(&quot;PLCTool&quot;);
hostcommand=secsInterface.getMessageBean(&quot;HostCommandSTOP&quot;);

 //initialize HCACK value in device. Device should overwrite this with a calculated HCACK.
/Devices/DemoServers_Servers/HCACK-&gt;setIntValue(99);

/Devices/DemoServers_Servers/STOPFlag-&gt;setIntValue(99); //doing this triggers the STOPFlag script

//wait up to 2000 ms for STARTFlag to change from 99 to some other number which is the HCACK for the reply message

count=0;
hcack=99;
while ((hcack==99) &amp;&amp; (count&lt;10)) {
    java.lang.Thread.sleep(200);
    count++;
    hcack=/Devices/DemoServers_Servers/HCACK-&gt;getIntValue();
   // print(count+&quot; &quot;+hcack);//debugging
}

//if hcack is still 99 there is a problem with the PLC program, so send error code 99 for PLC timeout

//send reply with the HCACK from the Device

reply = secsInterface.getMessageBean(&quot;HostCommandReply&quot;);
reply.setHCACK(Java.to([hcack],&quot;byte[]&quot;));
//alternatively, the HCACK value can be set this way:
//var SecsFormat10 =  Java.type(&quot;com.ergotech.secs.SecsFormat10&quot;);
//reply.setHCACKFormat ( new SecsFormat10(hack));
reply.sendMessage(); 

} catch (e) {
    print(&quot;Error in HostCommandSTOP script &quot;);
    print(e);    
}
</Script>
      <Description Class="java.lang.String">Simple Host STOP Command handler which will send a reply to the host</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">StopCommandtParams</Name>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Children Class="java.util.Vector">
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">Command</Name>
              <ItemType Class="java.lang.Integer">20</ItemType>
              <DefaultValue Class="java.lang.String">STOP</DefaultValue>
              <IsKey Class="java.lang.Boolean">true</IsKey>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">unnamed4</Name>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
            </com.ergotech.transsecs.secs.ItemData>
          </Children>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">HostCommandRejectedBadParam</Name>
      <Stream Class="java.lang.Integer">2</Stream>
      <Function Class="java.lang.Integer">42</Function>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2007-09-09 07:45:36.427 MDT</ModificationDate>
      <MessageDirection Class="java.lang.Integer">2</MessageDirection>
      <Description Class="java.lang.String">Send this to the host if the command is rejected because of bad parameters (hcack=3) with the list of bad parameters.
</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">datalist</Name>
          <Children Class="java.util.Vector">
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">HCACK</Name>
              <ItemType Class="java.lang.Integer">10</ItemType>
              <DefaultValue Class="java.lang.String">3</DefaultValue>
              <Publish Class="java.lang.Boolean">true</Publish>
              <Description Class="java.lang.String">Use this in the simulator to send a rejected host command response to the host&#xd;
</Description>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">unnamed14</Name>
              <Children Class="java.util.ArrayList">
                <com.ergotech.transsecs.secs.ItemData>
                  <Name Class="java.lang.String">unnamed1</Name>
                  <Children Class="java.util.ArrayList">
                    <com.ergotech.transsecs.secs.ItemData>
                      <Name Class="java.lang.String">CPName</Name>
                      <ItemType Class="java.lang.Integer">20</ItemType>
                      <DefaultValue Class="java.lang.String">BadName</DefaultValue>
                      <Publish Class="java.lang.Boolean">true</Publish>
                      <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
                      <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
                    </com.ergotech.transsecs.secs.ItemData>
                    <com.ergotech.transsecs.secs.ItemData>
                      <Name Class="java.lang.String">CPACK</Name>
                      <ItemType Class="java.lang.Integer">10</ItemType>
                      <DefaultValue Class="java.lang.String">1</DefaultValue>
                      <Description Class="java.lang.String">bad CPNAME</Description>
                      <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
                      <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
                    </com.ergotech.transsecs.secs.ItemData>
                  </Children>
                  <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
                </com.ergotech.transsecs.secs.ItemData>
              </Children>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
            </com.ergotech.transsecs.secs.ItemData>
          </Children>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">HostCommandReply</Name>
      <Stream Class="java.lang.Integer">2</Stream>
      <Function Class="java.lang.Integer">42</Function>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2007-09-09 07:45:36.427 MDT</ModificationDate>
      <MessageDirection Class="java.lang.Integer">2</MessageDirection>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">Send this to the host with hcack of 0 or 4 if accepted, 1 if the host command was unrecognized, 2 if cannot perform now, or 5 if already in the requested condition. The example scripts for the host messages will select the HCACK to send with this message.
</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">datalist</Name>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Children Class="java.util.Vector">
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">HCACK</Name>
              <ItemType Class="java.lang.Integer">10</ItemType>
              <DefaultValue Class="java.lang.String">0</DefaultValue>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Description Class="java.lang.String">//this value is set whenever the HCACK value changes. &#xd;
//The HostCommandReply is sent by the hostCommandSTOP or HostCommandSTART script.</Description>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">unnamed14</Name>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
            </com.ergotech.transsecs.secs.ItemData>
          </Children>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">Multiblock Request</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">1</Function>
      <ExpectsReply Class="java.lang.Boolean">true</ExpectsReply>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ResponseMessageName Class="java.lang.String">Multiblock Requst ACK</ResponseMessageName>
      <ModificationDate Class="java.util.Date">2007-09-09 07:20:43.820 MDT</ModificationDate>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">Mutliblock requst. Use for Testing. This message is not required for recipe handling.
Automatically reply with S7F2 Multiblock Requst ACK</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">RecipeParams</Name>
          <Publish Class="java.lang.Boolean">true</Publish>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Children Class="java.util.Vector">
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">PPID</Name>
              <ItemType Class="java.lang.Integer">20</ItemType>
              <DefaultValue Class="java.lang.String">0</DefaultValue>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">LENGTH</Name>
              <ItemType Class="java.lang.Integer">99</ItemType>
              <DefaultValue Class="java.lang.String">0</DefaultValue>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
          </Children>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">Multiblock Requst ACK</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">2</Function>
      <PeepOnlyMessage Class="java.lang.Boolean">true</PeepOnlyMessage>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2006-09-05 17:27:48.0 MDT</ModificationDate>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">ACK the delete recipe request</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">PPGNT</Name>
          <ItemType Class="java.lang.Integer">10</ItemType>
          <DefaultValue Class="java.lang.String">0</DefaultValue>
          <Publish Class="java.lang.Boolean">true</Publish>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Description Class="java.lang.String">0=Accepted
1=Permission not granted
2=Length Error (not useful for this message)
4=PPID not found
7=Storage Limit Error (not useful for this message)
64-255 custom error code</Description>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
          <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">ProcessProgramSend</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">3</Function>
      <ExpectsReply Class="java.lang.Boolean">true</ExpectsReply>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2007-09-09 07:20:43.820 MDT</ModificationDate>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Script Class="java.lang.String">//Basic handling of S7F3&#xd;
var TransSecsController = Java.type(&quot;com.ergotech.transsecs.secs.TransSecsController&quot;);&#xd;
var Logger = Java.type(&quot;org.apache.log4j.Logger&quot;);&#xd;
&#xd;
&#xd;
//functions must be defined at the top of the script&#xd;
&#xd;
//reply message&#xd;
function sendReply(ackc7) {&#xd;
    print(&quot;Sending S7F4 to host with ACKC7: &quot; + ackc7); &#xd;
    reply = controller.getMessageBean(&quot;ProcessProgramACK&quot;);&#xd;
    reply.setACKC7(Java.to([ackc7],&quot;byte[]&quot;)); //this is tricky, but correct&#xd;
    reply.sendMessage();  &#xd;
}&#xd;
&#xd;
&#xd;
&#xd;
print(&quot;S7F3 Received from host&quot;);&#xd;
&#xd;
try {&#xd;
  controller=TransSecsController.findController(&quot;PLCRecipeTool&quot;);//enter the name of your tool project here  &#xd;
  msgLogger = Logger.getLogger(&quot;com.ergotech.transsecs.secs.Log4JLogger&quot;); //this is the logger which logs the SECS/GEM messages  &#xd;
  msgLogger.info(&quot;S7F3 Recieived from host&quot;); //log an info level message to the main log&#xd;
 &#xd;
  msg=controller.getMessageBean(&quot;ProcessProgramSend&quot;); //ProcessProgramSend is the name of the S7F3 message&#xd;
				&#xd;
   ppid = msg.getPPID();&#xd;
   print(&quot;PPID from host: &quot; + ppid);&#xd;
   msgLogger.debug(&quot;PPID from host: &quot; + ppid); //log a debug message&#xd;
   ppbody = msg.getPPBODY();&#xd;
   print(&quot;PPBody is &quot;+ppbody); &#xd;
   msgLogger.debug(&quot;PPBody from host: &quot; + ppbody); //log a debug message&#xd;
   &#xd;
   //make sure the flags we use to process the S7F3 are set to 0 in the PLC to start&#xd;
   /Devices/PLCSimulator_Servers/S7F3RecipeProcessComplete-&gt;setIntValue(0);&#xd;
  &#xd;
  //store the recipe parameters. Use the PLC Device Driver you have set up for&#xd;
  //your PLC instead of &quot;PLCSimulator&quot;&#xd;
   /Devices/PLCSimulator_Servers/S7F3PPID-&gt;setStringValue(ppid);&#xd;
   /Devices/PLCSimulator_Servers/S7F3PPBody-&gt;setStringValue(ppbody);&#xd;
   &#xd;
   //set the trigger in the PLC which indicates that a recipe has been received&#xd;
   &#xd;
  /Devices/PLCSimulator_Servers/S7F3RecievedNotification-&gt;setIntValue(1);&#xd;
  &#xd;
  //Let the PLC process the recipe data, wait for S7F3RecipeProcessComplete to be non-zero&#xd;
  &#xd;
  //wait up to 5 seconds for PLC to process the message data (this time is arbitrary and probably too long)&#xd;
  ackc7=0; //default set to failure case&#xd;
  flag = /Devices/PLCSimulator_Servers/S7F3RecipeProcessComplete-&gt;getIntValue(); //will be 0 to start&#xd;
 // /Devices/PLCSimulator_Servers/S7F3RecipeProcessComplete-&gt;setIntValue(2); //for testing only (without a real PLC)&#xd;
   for (i=0;i&lt;50;i++) {&#xd;
      //for the simulator which is a BroadcastServer in PLCSimulator, use getIntValue() to get the value&#xd;
     flag = /Devices/PLCSimulator_Servers/S7F3RecipeProcessComplete-&gt;getIntValue(); &#xd;
     //for a real PLC, use triggerRead() to get the value&#xd;
    // flag = /Devices/PLCSimulator_Servers/S7F3RecipeProcessComplete-&gt;triggerRead();&#xd;
     if (flag&gt;0) {&#xd;
         if (flag==99) { //99 indicates success, recipe was correctly processed&#xd;
             ackc7=0;&#xd;
             }&#xd;
          else {&#xd;
             ackc7=flag;&#xd;
          }&#xd;
         break;&#xd;
      }&#xd;
     java.lang.Thread.sleep(100); //100 ms (this can loop up to 50 times for a total of 5000 ms = 5 seconds)&#xd;
      &#xd;
   }&#xd;
  if (flag==0) {&#xd;
      ackc7=88;//PLC did not process the recipe data&#xd;
   } &#xd;
  //send the reply with the ackc7 code&#xd;
  sendReply(ackc7);&#xd;
  &#xd;
  //now reset the flags in the PLC&#xd;
  /Devices/PLCSimulator_Servers/S7F3RecievedNotification-&gt;setIntValue(0);&#xd;
  /Devices/PLCSimulator_Servers/S7F3RecipeProcessComplete-&gt;setIntValue(0);&#xd;
  &#xd;
  } catch (e) {&#xd;
    print(&quot;Error in  S7F3 script: \n&quot;+e.stack);&#xd;
    print(e);    &#xd;
    &#xd;
      &#xd;
  }&#xd;
  </Script>
      <Description Class="java.lang.String">S7F3 recipe send message
</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">StartCommandParams</Name>
          <Publish Class="java.lang.Boolean">true</Publish>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Children Class="java.util.Vector">
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">PPID</Name>
              <ItemType Class="java.lang.Integer">20</ItemType>
              <DefaultValue Class="java.lang.String">0</DefaultValue>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Description Class="java.lang.String">The recipe id or name</Description>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">PPBODY</Name>
              <ItemType Class="java.lang.Integer">20</ItemType>
              <DefaultValue Class="java.lang.String">0</DefaultValue>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Description Class="java.lang.String">The recipe data</Description>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
          </Children>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">ProcessProgramACK</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">4</Function>
      <PeepOnlyMessage Class="java.lang.Boolean">true</PeepOnlyMessage>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2006-09-05 17:27:48.0 MDT</ModificationDate>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">ACK the for the recipe send</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">ACKC7</Name>
          <ItemType Class="java.lang.Integer">10</ItemType>
          <DefaultValue Class="java.lang.String">0</DefaultValue>
          <Publish Class="java.lang.Boolean">true</Publish>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Script Class="java.lang.String">&#xd;
</Script>
          <Description Class="java.lang.String">0=Accepted
1=Permission not granted
2=Length Error
4=PPID not found (not used for this message)
7=Storage Limit Error
64-255 custom error code</Description>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
          <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">ProcessProgramRequest</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">5</Function>
      <ExpectsReply Class="java.lang.Boolean">true</ExpectsReply>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2006-09-05 17:27:48.0 MDT</ModificationDate>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Script Class="java.lang.String">//S7F5 received&#xd;
&#xd;
var TransSecsController = Java.type(&quot;com.ergotech.transsecs.secs.TransSecsController&quot;);&#xd;
var SecsFormat00 = Java.type(&quot;com.ergotech.secs.SecsFormat00&quot;);&#xd;
var Logger = Java.type(&quot;org.apache.log4j.Logger&quot;);&#xd;
&#xd;
//functions must be defined at the top of the script&#xd;
&#xd;
//reply message&#xd;
function sendReply(ppid,ppbody) {&#xd;
    print(&quot;Sending S7F6 to host&quot;); &#xd;
    reply = controller.getMessageBean(&quot;ProcessProgramData&quot;); //ProcessProgramData is the name of the S7F6&#xd;
    reply.setPPID(ppid);&#xd;
    reply.setPPBODY(ppbody);&#xd;
    reply.sendMessage();  &#xd;
}&#xd;
&#xd;
//reply message for empty list (failure case if PPID does not exist)&#xd;
function sendEmptyReply() {&#xd;
    print(&quot;Sending empty S7F6 to host&quot;); &#xd;
    reply = controller.getMessageBean(&quot;ProcessProgramDataError&quot;);//ProcessProgramDataError is the name of the S7F6 with an empty list&#xd;
  	reply.sendMessage();&#xd;
}&#xd;
&#xd;
print(&quot;S7F5 Received from host&quot;);&#xd;
&#xd;
try {&#xd;
  controller=TransSecsController.findController(&quot;PLCRecipeTool&quot;);//enter the name of your tool project here  &#xd;
  msgLogger = Logger.getLogger(&quot;com.ergotech.transsecs.secs.Log4JLogger&quot;); //this is the logger which logs the SECS/GEM messages  &#xd;
  msgLogger.info(&quot;S7F5 Recieived from host&quot;); //log an info level message to the main log&#xd;
 &#xd;
  msg=controller.getMessageBean(&quot;ProcessProgramRequest&quot;); //ProcessProgramRequest is the name of the S7F5 message&#xd;
				&#xd;
  ppid = msg.getPPID();&#xd;
  print(&quot;PPID requested: &quot; + ppid);&#xd;
  msgLogger.debug(&quot;PPID requested: &quot; + ppid); //log a debug message&#xd;
  &#xd;
  //set the PPID value to the PLC and reset the S7F5DataReady flag&#xd;
   /Devices/PLCSimulator_Servers/S7F5PPID-&gt;setStringValue(ppid);&#xd;
   /Devices/PLCSimulator_Servers/S7F5DataReady-&gt;setIntValue(0);&#xd;
  &#xd;
  //prepare to get the PPBody from the PLC&#xd;
  //set the flag in the PLC which indicates that an S7F5 has been received&#xd;
  &#xd;
  /Devices/PLCSimulator_Servers/S7F5RequestPPBodyFlag-&gt;setIntValue(1);&#xd;
  &#xd;
  //wait a couple seconds for the PPBody value to be set by the PLC (watch for S7F5DataReady flag to go high)&#xd;
  &#xd;
 flag=0; //default to failure case&#xd;
 // /Devices/PLCSimulator_Servers/S7F3RecipeProcessComplete-&gt;setIntValue(2); //for testing only (without a real PLC)&#xd;
   for (i=0;i&lt;20;i++) {&#xd;
      //for the simulator which is a BroadcastServer in PLCSimulator, use getIntValue() to get the value&#xd;
     flag=/Devices/PLCSimulator_Servers/S7F5DataReady-&gt;getIntValue();&#xd;
     //for a real PLC, use triggerRead() to get the value&#xd;
    // flag = /Devices/PLCSimulator_Servers/S7F5DataReady-&gt;getIntValue()-&gt;triggerRead();&#xd;
     if (flag&gt;0) {        &#xd;
         break;&#xd;
      }&#xd;
     java.lang.Thread.sleep(100); //100 ms, looped up to 20 times =2000ms (2 seconds)&#xd;
      &#xd;
   }&#xd;
   flag=1;&#xd;
   //if the flag==0 then this did not succeed so need to send an emtpy list S7F6&#xd;
   //if the flag==99 then the PPID did not exist, so need to send the empty reply&#xd;
   if (flag!=1) {&#xd;
       sendEmptyReply();&#xd;
  &#xd;
   } else {//only if flag is &quot;1&quot;&#xd;
     //get the ppbody from a simulator (use getStringValue())&#xd;
    ppbody=/Devices/PLCSimulator_Servers/S7F5PPBody-&gt;getStringValue();  &#xd;
       &#xd;
   //get the ppbody from a real PLC (use triggerRead())&#xd;
    // ppbody=/Devices/PLCSimulator_Servers/S7F5PPBody-&gt;triggerRead();&#xd;
        &#xd;
     print(&quot;PPBody for PPID &quot; +ppid+&quot; is &quot;+ppbody); &#xd;
     msgLogger.debug(&quot;PPBody for PPID &quot; +ppid+&quot; is &quot;+ppbody); //log a debug message&#xd;
     &#xd;
     sendReply(ppid,ppbody);&#xd;
   }&#xd;
&#xd;
   &#xd;
     &#xd;
  //now reset the flags in the PLC&#xd;
  /Devices/PLCSimulator_Servers/S7F5RequestPPBodyFlag-&gt;setIntValue(0);&#xd;
  /Devices/PLCSimulator_Servers/S7F5DataReady-&gt;setIntValue(0);&#xd;
  &#xd;
  } catch (e) {&#xd;
    print(&quot;Error in  S7F5 script: \n&quot;+e.stack);&#xd;
    print(e);    &#xd;
    &#xd;
      &#xd;
  }&#xd;
  </Script>
      <Description Class="java.lang.String">Request a process program (recipe) from the host, or the host requests this recipe from the tool</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">PPID</Name>
          <ItemType Class="java.lang.Integer">20</ItemType>
          <DefaultValue Class="java.lang.String">0</DefaultValue>
          <Publish Class="java.lang.Boolean">true</Publish>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
          <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">ProcessProgramData</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">6</Function>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2007-09-09 07:20:43.820 MDT</ModificationDate>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">The requested recipe</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">RecipeParams</Name>
          <Publish Class="java.lang.Boolean">true</Publish>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Children Class="java.util.Vector">
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">PPID</Name>
              <ItemType Class="java.lang.Integer">20</ItemType>
              <DefaultValue Class="java.lang.String">0</DefaultValue>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
            <com.ergotech.transsecs.secs.ItemData>
              <Name Class="java.lang.String">PPBODY</Name>
              <ItemType Class="java.lang.Integer">20</ItemType>
              <DefaultValue Class="java.lang.String">0</DefaultValue>
              <Publish Class="java.lang.Boolean">true</Publish>
              <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
              <Parent Class="com.ergotech.transsecs.secs.ItemData" reference="../../.."/>
              <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
            </com.ergotech.transsecs.secs.ItemData>
          </Children>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">ProcessProgramDataError</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">6</Function>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2007-09-09 07:20:43.820 MDT</ModificationDate>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">error - cannot send recipe</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">EmptyList</Name>
          <Publish Class="java.lang.Boolean">true</Publish>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">ProcessProgramDeleteRequest</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">17</Function>
      <ExpectsReply Class="java.lang.Boolean">true</ExpectsReply>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2007-09-09 07:20:43.820 MDT</ModificationDate>
      <MessageDirection Class="java.lang.Integer">1</MessageDirection>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">Request to delete one or more recipes stored on the tool</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">ListToDelete</Name>
          <Publish Class="java.lang.Boolean">true</Publish>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">ProcessProgramDeleteACK</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">18</Function>
      <PeepOnlyMessage Class="java.lang.Boolean">true</PeepOnlyMessage>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2006-09-05 17:27:48.0 MDT</ModificationDate>
      <MessageDirection Class="java.lang.Integer">2</MessageDirection>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">ACK the delete recipe request</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">ACKC7</Name>
          <ItemType Class="java.lang.Integer">10</ItemType>
          <DefaultValue Class="java.lang.String">0</DefaultValue>
          <Publish Class="java.lang.Boolean">true</Publish>
          <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
          <Description Class="java.lang.String">0=Accepted
1=Permission not granted
2=Length Error (not useful for this message)
4=PPID not found
7=Storage Limit Error (not useful for this message)
64-255 custom error code</Description>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
          <AllowsChildren Class="java.lang.Boolean">false</AllowsChildren>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">EPPDRequest</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">19</Function>
      <ExpectsReply Class="java.lang.Boolean">true</ExpectsReply>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2000-11-14 09:02:02.0 MST</ModificationDate>
      <MessageDirection Class="java.lang.Integer">1</MessageDirection>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">Request list of process programs stored on the tool
</Description>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
    <com.ergotech.transsecs.secs.MessageData>
      <Name Class="java.lang.String">ProcessProgramList</Name>
      <Stream Class="java.lang.Integer">7</Stream>
      <Function Class="java.lang.Integer">20</Function>
      <HandleAsHostMessage Class="java.lang.Boolean">false</HandleAsHostMessage>
      <ModificationDate Class="java.util.Date">2007-09-09 07:20:43.820 MDT</ModificationDate>
      <MessageDirection Class="java.lang.Integer">2</MessageDirection>
      <DeviceName Class="java.lang.String">&lt;none&gt;</DeviceName>
      <Description Class="java.lang.String">Return list of recipes stored on tool</Description>
      <Children Class="java.util.Vector">
        <com.ergotech.transsecs.secs.ItemData>
          <Name Class="java.lang.String">ListOfPPIDs</Name>
          <Publish Class="java.lang.Boolean">true</Publish>
          <Parent Class="com.ergotech.transsecs.secs.MessageData" reference="../../.."/>
        </com.ergotech.transsecs.secs.ItemData>
      </Children>
      <Parent Class="com.ergotech.transsecs.secs.EquipmentData" reference="../../.."/>
    </com.ergotech.transsecs.secs.MessageData>
  </Children>
</com.ergotech.transsecs.secs.EquipmentData>